#! /usr/bin/python
#
#
import	sys
import	string
import	time
import	platform
import	geoip

#######################################################
#
# DXCLUSTER log file analyzer
#
# (c) 2009 - HA5DI
#
# 19-October-2011
#
# ha5di@freemail.hu
#
#######################################################

version = "1.5"

def ConCallLookup(s):
    n = 0
    	
    for p in lstcon:
	if p[0]==s:
	    return n
	    
	n += 1
	    
    return -1

def TimCallLookup(s):
    n = 0
    	
    for p in timcon:
	if p[0]==s:
	    return n
	    
	n += 1
	    
    return -1
    
def FormatTime(n):
    t = time.gmtime(n)
    s = time.strftime("%d-%m-%Y %H:%M:%S", t)
    return s
    
def FormatDuration(n):
    m = int(n/60) # duration in minutes
    xmin = m%60
    xhr  = m/60
    xday = xhr/24
    xhr = xhr%24
    
    if xday==0:
        s = '%02d:%02d ' % (xhr, xmin)    
    else:
        s = '%dd %02d:%02d ' % (xday, xhr, xmin)    
    
    return s
    
#######################################################
# Main program
#######################################################


if len(sys.argv)<>2:
    print ""
    print "DXCLUSTER log file analyzer v"+version
    print
    print "(c) 2009-2011 - ha5di, ha5di@freemail.hu"
    print
    print "Usage:"
    print 
    print "slogan <DIXSPIDER logfile>"
    print
    
    sys.exit(-1)
    
fname = sys.argv[1]


lstcon = []
st = []

# Read DXProt / DXCommand lines from log file to a list

try:
    fp = open(fname)

except IOError:
    print "Can't open log file"
    sys.exit(1)

tmfirst = 0
tmlast  = 0
logerr	= 0

while 1:
    s = fp.readline()

    if len(s)==0:
	break

    w = s.strip().split('^')

    if len(w)<2:
	continue
    
    if len(w[0])<>10:
	continue

    if tmfirst==0:
	tmfirst = float(w[0])
	
    tmlast = float(w[0])
    	    
    if w[1][:2]<>'DX':
	continue
		
    st.append(s)
    
fp.close()

# Check input file validity

if len(st)==0:
    print "Input file is not a valid Spider log"
    sys.exit(2)    
    
# Analyze log file from list
    
for p in st:
	
    w = p.strip().split('^')

    if w[1][:3]<>'DXC':
	continue

    v = w[2].split()

    if not (v[1]=='connected' or v[1]=='disconnected'):
	continue

    
    if v[1]=='connected':
	if ConCallLookup(v[0])<0:
    	    lstcon.append([v[0], 0, 0, 0, [[v[3],0]], 0, float(w[0]), 0])
    	    
    	    
    	n = ConCallLookup(v[0])
    	
    	if lstcon[n][5]<>0:
    	    logerr += 1		# Connection in already conencted state
    	    
    	# Connection count
    	
    	lstcon[n][1] +=1
	
	# First connection time correction
	
	if lstcon[n][2]==0:
	    lstcon[n][2]=float(w[0])
	    	    
	
	# Last connection time
	    
	if lstcon[n][3]<w[0]:
	    lstcon[n][3]=float(w[0])
	    
	# IP address

	k = 0
	f = 0
		
	if len(lstcon[n][4])<>0:	
    	    for q in lstcon[n][4]:
	        
		if q[0]==v[3]:
		    f = 1
		    break
		
		k += 1

	if f<>0:
	    lstcon[n][4][k][1] += 1
	else:
	    lstcon[n][4].append([v[3],1])	    

	# Accumulated connection time
	
	lstcon[n][5] = 1
	lstcon[n][6] = float(w[0])
	
    else:
	
	# Disconnect
	
	if ConCallLookup(v[0])<0:

	    # Already connected station when log starts
	    
	    lstcon.append([v[0], 0, 0, 0, [], 0, 0, float(w[0])-tmfirst])
	    	
	else:
	    n = ConCallLookup(v[0])

	    if lstcon[n][5]==0: 
		logerr += 1 # Disconenct in disconnected state
		
	    else:
		lstcon[n][5] = 0
		condur = float(w[0])-lstcon[n][6]
		lstcon[n][6] = 0    
		lstcon[n][7] += condur

# Find open connections

k = 0

for p in lstcon:
    if p[5]<>0:
	lstcon[k][5] = 0
	lstcon[k][7] += tmlast - lstcon[k][6]	
	lstcon[k][6] = 0

    k += 1
    		    
lstcon.sort()


# Build up connection statistic vs. time

timcon = []

for p in st:
	
    w = p.strip().split('^')

    if w[1][:3]<>'DXC':
	continue

    v = w[2].split()

    if v[1]=='disconnected':
	if TimCallLookup(v[0])<0:
    	    timcon.append([v[0], tmfirst, 0])
    	    
    if v[1]=='connected':
	if TimCallLookup(v[0])<0:
    	    timcon.append([v[0], float(w[0]), 1])
	
# Clean-up list, keep only overflow from previous log

while 1:
    f = 0
    k = 0

    for p in timcon:
    
    	if p[2]==1:
	    del timcon[k]
	    f = 1
	    break	
	k += 1
    
    if f==0:
	break    

statcon = [[len(timcon), tmfirst]]

overcon = len(timcon)

# Build op stats

for p in st:
	
    w = p.strip().split('^')

    if w[1][:3]<>'DXC':
	continue

    v = w[2].split()

    n = TimCallLookup(v[0])

    if v[1]=='disconnected':
	if n<0:	    
	    pass
	
	else:    
	    del timcon[n]
    	    
    if v[1]=='connected':
	if n<0:
    	    timcon.append([v[0], float(w[0]), 0])
    	
	else:
	    pass
	    
    if v[1]=='connected' or v[1]=='disconnected':	    
	statcon.append([len(timcon), float(w[0])])
	
# Initialize GeoIP database

if geoip.dbload(sys.argv[0])<>0:
    print "Can't open IP database"
    sys.exit(3)

# Print report

maxcon = -1
maxtim = 0

for p in statcon:
    
    if p[0]>maxcon:
	maxcon = p[0]
	maxtim = p[1]
    
print
print " "*20+"#"*79
print " "*20+"#%21s %-55s%s" % ("Slogan version :", version + " - (C) ha5di@freemail.hu", "#")
print " "*20+"#"*79
print " "*20+"#%21s %-55s%s" % ("Operating System :", platform.system(), "#")
print " "*20+"#%21s %-55s%s" % ("Python Version :", platform.python_version(), "#")
print " "*20+"#%21s %-55s%s" % ("Machine :", platform.machine(), "#")
print " "*20+"#%21s %-55s%s" % ("Processor :", platform.processor(), "#")
print " "*20+"#"+"-"*77+"#"
print " "*20+"#%21s %-55s%s" % ("Log file :", fname, "#")
print " "*20+"#%21s %s UTC%33s" % ("Date of creation :", FormatTime(time.time()), "#")
print " "*20+"#%21s %s UTC%33s" % ("First log entry :", FormatTime(tmfirst), "#")
print " "*20+"#%21s %s UTC%33s" % ("Last log entry :", FormatTime(tmlast), "#")
print " "*20+"#%21s %-5d%51s" % ("Number of users :", len(lstcon), "#")
print " "*20+"#%21s %-5d%51s" % ("Already connected :", overcon, "#")
print " "*20+"#%21s %-5d%51s" % ("Max connected user :", maxcon, "#")
print " "*20+"#%21s %s UTC%33s" % ("Max connected on :", FormatTime(maxtim), "#")
print " "*20+"#%21s %-5d%51s" % ("Log errors :", logerr, "#")
print " "*20+"#"*79
print

print "#"*122
print "     Call    Cnt     FirstConnect          LastConnect         ConTime IPCnt     LastIP               IPCountry"
print "-"*122

for p in lstcon:

    s  = "%-12s%4d  " % (p[0], p[1])    

    if p[1]==0:
        s += "%s" % (" "*40)    
    
    elif p[1]==1:
        s += "%s  %s" % (FormatTime(p[2]), " "*19)    
    
    else:
        s += "%s  %s" % (FormatTime(p[2]), FormatTime(p[3]))    
    
    s += "%12s" % (FormatDuration(p[7]))

    if len(p[4])==0:
    	# Was connected at the beginning but never reconnects
    
        s += "%4d  %-20s" % (len(p[4]), '')
	s += "------"	
	    
    else:
        s += "%4d  %-26s" % (len(p[4]), p[4][-1][0])

	if geoip.ipchk(p[4][-1][0])==0:

	    w = geoip.iplookup(geoip.ip2num(p[4][-1][0]))
    
	    if len(w)==0:
		s += "reserved address"	
	    else:
    		s += "%s" % (w[4])

	else:
	
	    s += "%s" % ('******')
    print s
    
print "#"*122
print

sys.exit(0)
